Index: connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/WrappedResultSetJDBC4.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/WrappedResultSetJDBC4.java	(revision 0)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/WrappedResultSetJDBC4.java	(working copy)
@@ -19,8 +19,11 @@
  * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
  * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
  */
-package org.jboss.resource.adapter.jdbc.jdk6;
+package org.jboss.resource.adapter.jdbc.jdbc4;
 
+import org.jboss.resource.adapter.jdbc.WrappedResultSet;
+import org.jboss.resource.adapter.jdbc.WrappedStatement;
+
 import java.io.InputStream;
 import java.io.Reader;
 import java.sql.NClob;
@@ -29,18 +32,15 @@
 import java.sql.SQLException;
 import java.sql.SQLXML;
 
-import org.jboss.resource.adapter.jdbc.WrappedResultSet;
-import org.jboss.resource.adapter.jdbc.WrappedStatement;
-
 /**
  * WrappedResultSetJDK6.
  * 
  * @author <a href="adrian@jboss.com">Adrian Brock</a>
  * @version $Revision$
  */
-public class WrappedResultSetJDK6 extends WrappedResultSet
+public abstract class WrappedResultSetJDBC4 extends WrappedResultSet
 {
-   public WrappedResultSetJDK6(WrappedStatement statement, ResultSet resultSet)
+   public WrappedResultSetJDBC4(WrappedStatement statement, ResultSet resultSet)
    {
       super(statement, resultSet);
    }

Index: connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/CachedPreparedStatementJDBC4.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/CachedPreparedStatementJDBC4.java	(revision 0)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/CachedPreparedStatementJDBC4.java	(working copy)
@@ -19,8 +19,10 @@
  * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
  * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
  */
-package org.jboss.resource.adapter.jdbc.jdk6;
+package org.jboss.resource.adapter.jdbc.jdbc4;
 
+import org.jboss.resource.adapter.jdbc.CachedPreparedStatement;
+
 import java.io.InputStream;
 import java.io.Reader;
 import java.sql.NClob;
@@ -29,17 +31,15 @@
 import java.sql.SQLException;
 import java.sql.SQLXML;
 
-import org.jboss.resource.adapter.jdbc.CachedPreparedStatement;
-
 /**
- * CachedPreparedStatementJDK5.
+ * CachedPreparedStatementJDBC4.
  * 
  * @author <a href="adrian@jboss.com">Adrian Brock</a>
  * @version $Revision$
  */
-public class CachedPreparedStatementJDK6 extends CachedPreparedStatement
+public abstract class CachedPreparedStatementJDBC4 extends CachedPreparedStatement
 {
-   public CachedPreparedStatementJDK6(PreparedStatement ps) throws SQLException
+   public CachedPreparedStatementJDBC4(PreparedStatement ps) throws SQLException
    {
       super(ps);
    }

Index: connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/WrappedConnectionJDBC4.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/WrappedConnectionJDBC4.java	(revision 0)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/WrappedConnectionJDBC4.java	(working copy)
@@ -19,62 +19,41 @@
  * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
  * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
  */
-package org.jboss.resource.adapter.jdbc.jdk6;
+package org.jboss.resource.adapter.jdbc.jdbc4;
 
+import org.jboss.resource.adapter.jdbc.BaseWrapperManagedConnection;
+import org.jboss.resource.adapter.jdbc.WrappedConnection;
+
 import java.sql.Array;
 import java.sql.Blob;
-import java.sql.CallableStatement;
 import java.sql.Clob;
 import java.sql.Connection;
 import java.sql.NClob;
-import java.sql.PreparedStatement;
 import java.sql.SQLClientInfoException;
 import java.sql.SQLException;
 import java.sql.SQLXML;
-import java.sql.Statement;
 import java.sql.Struct;
 import java.util.Properties;
 
-import org.jboss.resource.adapter.jdbc.BaseWrapperManagedConnection;
-import org.jboss.resource.adapter.jdbc.WrappedCallableStatement;
-import org.jboss.resource.adapter.jdbc.WrappedConnection;
-import org.jboss.resource.adapter.jdbc.WrappedPreparedStatement;
-import org.jboss.resource.adapter.jdbc.WrappedStatement;
-
 /**
- * WrappedConnectionJDK6.
+ * WrappedConnectionJDBC4.
  * 
  * @author <a href="adrian@jboss.com">Adrian Brock</a>
  * @version $Revision$
  */
 @SuppressWarnings("unchecked")
-public class WrappedConnectionJDK6 extends WrappedConnection
+public abstract class WrappedConnectionJDBC4 extends WrappedConnection
 {
    /**
-    * Create a new WrappedConnectionJDK6.
+    * Create a new WrappedConnectionJDBC4.
     * 
     * @param mc the managed connection
     */
-   public WrappedConnectionJDK6(BaseWrapperManagedConnection mc)
+   public WrappedConnectionJDBC4(BaseWrapperManagedConnection mc)
    {
       super(mc);
    }
 
-   protected WrappedStatement wrapStatement(Statement statement)
-   {
-      return new WrappedStatementJDK6(this, statement);
-   }
-
-   protected WrappedPreparedStatement wrapPreparedStatement(PreparedStatement statement)
-   {
-      return new WrappedPreparedStatementJDK6(this, statement);
-   }
-
-   protected WrappedCallableStatement wrapCallableStatement(CallableStatement statement)
-   {
-      return new WrappedCallableStatementJDK6(this, statement);
-   }
-
    public Array createArrayOf(String typeName, Object[] elements) throws SQLException
    {
       lock();

Index: connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/WrappedCallableStatementJDBC4.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/WrappedCallableStatementJDBC4.java	(revision 0)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/WrappedCallableStatementJDBC4.java	(working copy)
@@ -19,8 +19,10 @@
  * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
  * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
  */
-package org.jboss.resource.adapter.jdbc.jdk6;
+package org.jboss.resource.adapter.jdbc.jdbc4;
 
+import org.jboss.resource.adapter.jdbc.WrappedCallableStatement;
+
 import java.io.InputStream;
 import java.io.Reader;
 import java.sql.Blob;
@@ -28,32 +30,23 @@
 import java.sql.Clob;
 import java.sql.NClob;
 import java.sql.PreparedStatement;
-import java.sql.ResultSet;
 import java.sql.RowId;
 import java.sql.SQLException;
 import java.sql.SQLXML;
 
-import org.jboss.resource.adapter.jdbc.WrappedCallableStatement;
-import org.jboss.resource.adapter.jdbc.WrappedResultSet;
-
 /**
- * WrappedCallableStatementJDK6.
+ * WrappedCallableStatementJDBC4.
  * 
  * @author <a href="adrian@jboss.com">Adrian Brock</a>
  * @version $Revision$
  */
-public class WrappedCallableStatementJDK6 extends WrappedCallableStatement
+public abstract class WrappedCallableStatementJDBC4 extends WrappedCallableStatement
 {
-   public WrappedCallableStatementJDK6(WrappedConnectionJDK6 lc, CallableStatement s)
+   public WrappedCallableStatementJDBC4(WrappedConnectionJDBC4 lc, CallableStatement s)
    {
       super(lc, s);
    }
    
-   protected WrappedResultSet wrapResultSet(ResultSet resultSet)
-   {
-      return new WrappedResultSetJDK6(this, resultSet);
-   }
-
    public boolean isClosed() throws SQLException
    {
       try

Index: connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/WrappedStatementJDBC4.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/WrappedStatementJDBC4.java	(revision 0)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/WrappedStatementJDBC4.java	(working copy)
@@ -19,33 +19,26 @@
  * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
  * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
  */
-package org.jboss.resource.adapter.jdbc.jdk6;
+package org.jboss.resource.adapter.jdbc.jdbc4;
 
-import java.sql.ResultSet;
+import org.jboss.resource.adapter.jdbc.WrappedStatement;
+
 import java.sql.SQLException;
 import java.sql.Statement;
 
-import org.jboss.resource.adapter.jdbc.WrappedResultSet;
-import org.jboss.resource.adapter.jdbc.WrappedStatement;
-
 /**
  * WrappedStatementJDK6.
  * 
  * @author <a href="adrian@jboss.com">Adrian Brock</a>
  * @version $Revision$
  */
-public class WrappedStatementJDK6 extends WrappedStatement
+public abstract class WrappedStatementJDBC4 extends WrappedStatement
 {
-   public WrappedStatementJDK6(WrappedConnectionJDK6 lc, Statement s)
+   public WrappedStatementJDBC4(WrappedConnectionJDBC4 lc, Statement s)
    {
       super(lc, s);
    }
 
-   protected WrappedResultSet wrapResultSet(ResultSet resultSet)
-   {
-      return new WrappedResultSetJDK6(this, resultSet);
-   }
-
    public boolean isClosed() throws SQLException
    {
       lock();

Index: connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/WrappedPreparedStatementJDBC4.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/WrappedPreparedStatementJDBC4.java	(revision 0)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/WrappedPreparedStatementJDBC4.java	(working copy)
@@ -19,38 +19,31 @@
  * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
  * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
  */
-package org.jboss.resource.adapter.jdbc.jdk6;
+package org.jboss.resource.adapter.jdbc.jdbc4;
 
+import org.jboss.resource.adapter.jdbc.WrappedPreparedStatement;
+
 import java.io.InputStream;
 import java.io.Reader;
 import java.sql.NClob;
 import java.sql.PreparedStatement;
-import java.sql.ResultSet;
 import java.sql.RowId;
 import java.sql.SQLException;
 import java.sql.SQLXML;
 
-import org.jboss.resource.adapter.jdbc.WrappedPreparedStatement;
-import org.jboss.resource.adapter.jdbc.WrappedResultSet;
-
 /**
  * WrappedPreparedStatementJDK6.
  * 
  * @author <a href="adrian@jboss.com">Adrian Brock</a>
  * @version $Revision$
  */
-public class WrappedPreparedStatementJDK6 extends WrappedPreparedStatement
+public abstract class WrappedPreparedStatementJDBC4 extends WrappedPreparedStatement
 {
-   public WrappedPreparedStatementJDK6(WrappedConnectionJDK6 lc, PreparedStatement s)
+   public WrappedPreparedStatementJDBC4(WrappedConnectionJDBC4 lc, PreparedStatement s)
    {
       super(lc, s);
    }
    
-   protected WrappedResultSet wrapResultSet(ResultSet resultSet)
-   {
-      return new WrappedResultSetJDK6(this, resultSet);
-   }
-
    public boolean isClosed() throws SQLException
    {
       lock();

Index: connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/CachedCallableStatementJDBC4.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/CachedCallableStatementJDBC4.java	(revision 0)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/jdbc4/CachedCallableStatementJDBC4.java	(working copy)
@@ -19,8 +19,10 @@
  * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
  * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
  */
-package org.jboss.resource.adapter.jdbc.jdk6;
+package org.jboss.resource.adapter.jdbc.jdbc4;
 
+import org.jboss.resource.adapter.jdbc.CachedCallableStatement;
+
 import java.io.InputStream;
 import java.io.Reader;
 import java.sql.Blob;
@@ -31,18 +33,16 @@
 import java.sql.SQLException;
 import java.sql.SQLXML;
 
-import org.jboss.resource.adapter.jdbc.CachedCallableStatement;
-
 /**
- * CachedCallableStatementJDK6.
+ * CachedCallableStatementJDBC4.
  * 
  * @author <a href="adrian@jboss.com">Adrian Brock</a>
  * @version $Revision$
  */
 @SuppressWarnings("deprecation")
-public class CachedCallableStatementJDK6 extends CachedCallableStatement
+public abstract class CachedCallableStatementJDBC4 extends CachedCallableStatement
 {
-   public CachedCallableStatementJDK6(CallableStatement cs) throws SQLException
+   public CachedCallableStatementJDBC4(CallableStatement cs) throws SQLException
    {
       super(cs);
    }

Index: connector/src/main/org/jboss/resource/adapter/jdbc/BaseWrapperManagedConnection.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/BaseWrapperManagedConnection.java	(revision 112935)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/BaseWrapperManagedConnection.java	(working copy)
@@ -21,6 +21,18 @@
  */
 package org.jboss.resource.adapter.jdbc;
 
+import org.jboss.logging.Logger;
+import org.jboss.resource.JBossResourceException;
+import org.jboss.resource.statistic.JBossConnectionStatistics;
+
+import javax.resource.ResourceException;
+import javax.resource.spi.ConnectionEvent;
+import javax.resource.spi.ConnectionEventListener;
+import javax.resource.spi.ConnectionRequestInfo;
+import javax.resource.spi.ManagedConnection;
+import javax.resource.spi.ManagedConnectionMetaData;
+import javax.resource.spi.ResourceAdapterInternalException;
+import javax.security.auth.Subject;
 import java.io.PrintWriter;
 import java.sql.CallableStatement;
 import java.sql.Connection;
@@ -37,20 +49,6 @@
 import java.util.concurrent.TimeUnit;
 import java.util.concurrent.atomic.AtomicBoolean;
 
-import javax.resource.ResourceException;
-import javax.resource.spi.ConnectionEvent;
-import javax.resource.spi.ConnectionEventListener;
-import javax.resource.spi.ConnectionRequestInfo;
-import javax.resource.spi.ManagedConnection;
-import javax.resource.spi.ManagedConnectionMetaData;
-import javax.resource.spi.ResourceAdapterInternalException;
-import javax.security.auth.Subject;
-
-import org.jboss.logging.Logger;
-import org.jboss.resource.JBossResourceException;
-
-import org.jboss.resource.statistic.JBossConnectionStatistics;
-
 /**
  * BaseWrapperManagedConnection
  *
@@ -103,21 +101,25 @@
    static
    {
       Class connectionFactory = null;
-      try
+      ClassNotFoundException ex = null;
+      for (String impl : WrappedConnectionFactory.IMPLEMENTATIONS)
       {
-         connectionFactory = BaseWrapperManagedConnection.class.forName("org.jboss.resource.adapter.jdbc.jdk6.WrappedConnectionFactoryJDK6");
-      }
-      catch (ClassNotFoundException e)
-      {
          try
          {
-            connectionFactory = BaseWrapperManagedConnection.class.forName("org.jboss.resource.adapter.jdbc.jdk5.WrappedConnectionFactoryJDK5");
+            connectionFactory = WrappedConnectionFactory.class.forName(impl);
+            break;
          }
-         catch (ClassNotFoundException ex)
+         catch (ClassNotFoundException e)
          {
-            throw new RuntimeException("Unabled to load wrapped connection factory", ex);
+            // ignore
+            ex = e;
+            e.printStackTrace();
          }
       }
+      if (connectionFactory == null)
+      {
+         throw new RuntimeException("Unabled to load wrapped connection factory", ex);
+      }
       try
       {
          wrappedConnectionFactory = (WrappedConnectionFactory) connectionFactory.newInstance();
Index: connector/src/main/org/jboss/resource/adapter/jdbc/WrappedConnectionFactory.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/WrappedConnectionFactory.java	(revision 112935)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/WrappedConnectionFactory.java	(working copy)
@@ -33,6 +33,10 @@
  */
 public interface WrappedConnectionFactory
 {
+   String[] IMPLEMENTATIONS = { "org.jboss.resource.adapter.jdbc.jdk7.WrappedConnectionFactoryJDK7",
+           "org.jboss.resource.adapter.jdbc.jdk6.WrappedConnectionFactoryJDK6",
+           "org.jboss.resource.adapter.jdbc.jdk5.WrappedConnectionFactoryJDK5" };
+
    WrappedConnection createWrappedConnection(BaseWrapperManagedConnection mc);
 
    CachedPreparedStatement createCachedPreparedStatement(PreparedStatement ps) throws SQLException;
Index: connector/src/main/org/jboss/resource/adapter/jdbc/jdk6/WrappedPreparedStatementJDK6.java
===================================================================
--- connector/src/main/org/jboss/resource/adapter/jdbc/jdk6/WrappedPreparedStatementJDK6.java	(revision 112935)
+++ connector/src/main/org/jboss/resource/adapter/jdbc/jdk6/WrappedPreparedStatementJDK6.java	(working copy)
@@ -32,6 +32,7 @@
 
 import org.jboss.resource.adapter.jdbc.WrappedPreparedStatement;
 import org.jboss.resource.adapter.jdbc.WrappedResultSet;
+import org.jboss.resource.adapter.jdbc.jdbc4.WrappedPreparedStatementJDBC4;
 
 /**
  * WrappedPreparedStatementJDK6.
@@ -39,7 +40,7 @@
  * @author <a href="adrian@jboss.com">Adrian Brock</a>
  * @version $Revision$
  */
-public class WrappedPreparedStatementJDK6 extends WrappedPreparedStatement
+public class WrappedPreparedStatementJDK6 extends WrappedPreparedStatementJDBC4
 {
    public WrappedPreparedStatementJDK6(WrappedConnectionJDK6 lc, PreparedStatement s)
    {
@@ -50,444 +51,4 @@
    {
       return new WrappedResultSetJDK6(this, resultSet);
    }
-
-   public boolean isClosed() throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement wrapped = getWrappedObject();
-         if (wrapped == null)
-            return true;
-         return wrapped.isClosed();
-      }
-      catch (Throwable t)
-      {
-         throw checkException(t);
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public boolean isPoolable() throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            return statement.isPoolable();
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setPoolable(boolean poolable) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setPoolable(poolable);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setAsciiStream(int parameterIndex, InputStream x, long length) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setAsciiStream(parameterIndex, x, length);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setAsciiStream(int parameterIndex, InputStream x) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setAsciiStream(parameterIndex, x);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setBinaryStream(int parameterIndex, InputStream x, long length) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setBinaryStream(parameterIndex, x, length);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setBinaryStream(int parameterIndex, InputStream x) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setBinaryStream(parameterIndex, x);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setBlob(int parameterIndex, InputStream inputStream, long length) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setBlob(parameterIndex, inputStream, length);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setBlob(int parameterIndex, InputStream inputStream) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setBlob(parameterIndex, inputStream);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setCharacterStream(int parameterIndex, Reader reader, long length) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setCharacterStream(parameterIndex, reader, length);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setCharacterStream(int parameterIndex, Reader reader) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setCharacterStream(parameterIndex, reader);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setClob(int parameterIndex, Reader reader, long length) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setClob(parameterIndex, reader, length);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setClob(int parameterIndex, Reader reader) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setClob(parameterIndex, reader);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setNCharacterStream(int parameterIndex, Reader value, long length) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setNCharacterStream(parameterIndex, value, length);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setNCharacterStream(int parameterIndex, Reader value) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setNCharacterStream(parameterIndex, value);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setNClob(int parameterIndex, NClob value) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setNClob(parameterIndex, value);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setNClob(int parameterIndex, Reader reader, long length) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setNClob(parameterIndex, reader, length);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setNClob(int parameterIndex, Reader reader) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setNClob(parameterIndex, reader);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setNString(int parameterIndex, String value) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setNString(parameterIndex, value);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setRowId(int parameterIndex, RowId x) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setRowId(parameterIndex, x);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
-
-   public void setSQLXML(int parameterIndex, SQLXML xmlObject) throws SQLException
-   {
-      lock();
-      try
-      {
-         PreparedStatement statement = getUnderlyingStatement();
-         try
-         {
-            statement.setSQLXML(parameterIndex, xmlObject);
-         }
-         catch (Throwable t)
-         {
-            throw checkException(t);
-         }
-      }
-      finally
-      {
-         unlock();
-      }
-   }
 }
